
#property copyright "Copyright  2009 Robert Dee"
#property link      "www.forexfactory.com"

#property indicator_chart_window
#property indicator_buffers 2
#property indicator_color1 Lime
#property indicator_color2 Red
#property indicator_width1 1.25
#property indicator_width2 1.25

extern bool vForceSignals = TRUE;
bool PaintSignalCandles = false;
bool PaintConfirmCandles = false;
extern int ConfirmPips = 4;
extern bool ShowPriceLabels = TRUE;
extern bool AlertPopups = TRUE;
string AlertSoundFile = "alert2.wav";
extern int AlertSoundRepeats = 2;
extern bool ShowAlertArrows = true;
double g_ibuf_124[];
double g_ibuf_128[];
double g_ibuf_132[];
double g_ibuf_136[];
double g_ibuf_140[];
double g_ibuf_144[];
double gda_148[];
int g_second_152;
int g_count_156;
int gi_160;
int gi_164;
double gd_168;
double gd_176;
bool gi_184;
bool gi_188;
int gi_192;
double Mult = 1;

//===
int init() {
   if (Digits == 3 ||  Digits == 5) {Mult = 10; ConfirmPips = ConfirmPips*10;}
   if (ShowAlertArrows == TRUE) SetIndexStyle(0, DRAW_ARROW);
   else SetIndexStyle(0, DRAW_NONE);
   SetIndexArrow(0, SYMBOL_ARROWUP);
   SetIndexEmptyValue(0, 0);
   if (ShowAlertArrows == TRUE) SetIndexStyle(1, DRAW_ARROW);
   else SetIndexStyle(1, DRAW_NONE);
   SetIndexArrow(1, SYMBOL_ARROWDOWN);
   SetIndexEmptyValue(1, 0);
   
   SetIndexBuffer(0, g_ibuf_124);
   SetIndexBuffer(1, g_ibuf_128);
  
   IndicatorDigits(Digits);
   IndicatorShortName("VFA");
   SetIndexLabel(0, "");
   SetIndexLabel(1, "");
   
   ArraySetAsSeries(gda_148, TRUE);
   ArrayResize(gda_148, Bars + 1);
   for (int l_index_0 = 0; l_index_0 < Bars; l_index_0++) {
      g_ibuf_124[l_index_0] = 0;
      g_ibuf_128[l_index_0] = 0;
      gda_148[l_index_0] = High[l_index_0] - Low[l_index_0];

   }
   return (0);
}

void PaintSignalCandle(int ai_0) {
   g_ibuf_132[ai_0] = Close[ai_0];
   g_ibuf_136[ai_0] = Open[ai_0];
}

void PaintConfirmCandle(int ai_0) {
   g_ibuf_140[ai_0] = Close[ai_0];
   g_ibuf_144[ai_0] = Open[ai_0];
}

void PrintPriceLabel(double a_price_0, int ai_8, color a_color_12) {
   string l_name_16 = "_pricelabel " + DoubleToStr(a_price_0, Digits) + " " + TimeToStr(ai_8, TIME_MINUTES);
   if (ObjectFind(l_name_16) != 0) {
      ObjectCreate(l_name_16, OBJ_ARROW, 0, ai_8, a_price_0);
      ObjectSet(l_name_16, OBJPROP_ARROWCODE, SYMBOL_LEFTPRICE);
      ObjectSet(l_name_16, OBJPROP_COLOR, a_color_12);
   }
}

int start() {
   double ld_0;
   double ld_8;
   double ld_16;
   double ld_24;
   double ld_32;
   double ld_40;
   double l_iadx_48;
   double l_iadx_56;
   double l_iadx_64;
   double l_ima_on_arr_72;
   double l_ima_on_arr_80;
   string ls_88;

   if (ArraySize(gda_148) < Bars + 1) {
      ArrayResize(gda_148, Bars + 1);
      for (int l_index_96 = 0; l_index_96 < Bars; l_index_96++) gda_148[l_index_96] = High[l_index_96] - Low[l_index_96];
   }
   int li_104 = IndicatorCounted();
   if (li_104 < 0) return (-1);
   if (li_104 > 0) li_104--;
   for (int li_100 = Bars - li_104; li_100 >= 0; li_100--) {
      ld_0 = 0;
      ld_32 = (iMACD(NULL, 0, 20, 40, 9, PRICE_CLOSE, MODE_MAIN, li_100 + 1) - iMACD(NULL, 0, 20, 40, 9, PRICE_CLOSE, MODE_MAIN, li_100 + 2)) / Point;
      ld_40 = (iBands(NULL, 0, 20, 2, 0, PRICE_CLOSE, MODE_UPPER, li_100 + 1) - iBands(NULL, 0, 20, 2, 0, PRICE_CLOSE, MODE_LOWER, li_100 + 1)) / Point;
      ld_0 = ld_32 * ld_40;
      ld_8 = 0;
      l_iadx_48 = iADX(NULL, 0, 13, PRICE_WEIGHTED, MODE_MAIN, li_100 + 1);
      l_iadx_56 = iADX(NULL, 0, 13, PRICE_WEIGHTED, MODE_PLUSDI, li_100 + 1);
      l_iadx_64 = iADX(NULL, 0, 13, PRICE_WEIGHTED, MODE_MINUSDI, li_100 + 1);
      ld_40 = iBands(NULL, 0, 20, 2, 0, PRICE_CLOSE, MODE_UPPER, li_100 + 1) - iBands(NULL, 0, 20, 2, 0, PRICE_CLOSE, MODE_LOWER, li_100 + 1);
      if (l_iadx_56 >= l_iadx_64) ld_8 = l_iadx_48 * ld_40;
      if (l_iadx_56 < l_iadx_64) ld_8 = -(l_iadx_48 * ld_40);
      ld_16 = 0;
      if (li_100 < Bars - 21) {
         l_ima_on_arr_72 = iMAOnArray(gda_148, 0, 10, 0, MODE_EMA, li_100 + 1);
         l_ima_on_arr_80 = iMAOnArray(gda_148, 0, 10, 0, MODE_EMA, li_100 + 11);
         ld_16 = 100.0 * ((l_ima_on_arr_72 - l_ima_on_arr_80) / l_ima_on_arr_80);
      }
      ld_24 = (High[li_100 + 1] - (Low[li_100 + 1])) / Point;
      if (gi_192 == 1 && ld_0 < 0.0 && ld_8 < 0.0) gi_192 = 0;
      if (gi_192 == 2 && ld_0 > 0.0 && ld_8 > 0.0) gi_192 = 0;
      if (vForceSignals == TRUE && gi_192 != 1) {
         if (ld_0 > 0.0) {
            if (ld_8 > 0.0) {
               if (ld_16 > 1.0) {
                  if (ld_24 >= 20.0) {
                     if (Close[li_100 + 1] > Open[li_100 + 1] + 1*Mult * Point) {
                        g_ibuf_124[li_100 + 1] = Low[li_100 + 1] - 5*Mult * Point;
                        if (PaintSignalCandles == TRUE) PaintSignalCandle(li_100 + 1);
                        gi_192 = 1;
                        gi_160 = Time[li_100 + 1];
                        gd_168 = High[li_100 + 1];
                        gd_176 = Low[li_100 + 1];
                        gi_184 = FALSE;
                        gi_188 = TRUE;
                     }
                  }
               }
            }
         }
      }
      if (vForceSignals == TRUE && gi_192 != 2) {
         if (ld_0 < 0.0) {
            if (ld_8 < 0.0) {
               if (ld_16 > 1.0) {
                  if (ld_24 >= 20.0) {
                     if (Close[li_100 + 1] < Open[li_100 + 1] - 1*Mult * Point) {
                        g_ibuf_128[li_100 + 1] = High[li_100 + 1] + 5*Mult * Point;
                        if (PaintSignalCandles == TRUE) PaintSignalCandle(li_100 + 1);
                        gi_192 = 2;
                        gi_160 = Time[li_100 + 1];
                        gd_168 = High[li_100 + 1];
                        gd_176 = Low[li_100 + 1];
                        gi_188 = FALSE;
                        gi_184 = TRUE;
                     }
                  }
               }
            }
         }
      }
      if (gi_184 == FALSE) {
         if (High[li_100] >= gd_168 + ConfirmPips * Point) {
            PaintConfirmCandle(li_100);
            gi_184 = TRUE;
         }
         if (Close[li_100 + 1] > gd_168) {
            PaintConfirmCandle(li_100 + 1);
            gi_184 = TRUE;
         }
      }
      if (gi_188 == FALSE) {
         if (Low[li_100] <= gd_176 - ConfirmPips * Point) {
            PaintConfirmCandle(li_100);
            gi_188 = TRUE;
         }
         if (Close[li_100 + 1] < gd_176) {
            PaintConfirmCandle(li_100 + 1);
            gi_188 = TRUE;
         }
      }

      if (ShowPriceLabels == TRUE) {
         if (g_ibuf_124[li_100 + 1] != 0.0) PrintPriceLabel(High[li_100 + 1] + ConfirmPips * Point, Time[li_100 + 1], Aqua);
         if (g_ibuf_124[li_100 + 1] != 0.0) PrintPriceLabel(High[li_100 + 1] + ConfirmPips * Point+110*Point, Time[li_100 + 1], Gold);
       
         if (g_ibuf_128[li_100 + 1] != 0.0) PrintPriceLabel(Low[li_100 + 1] - ConfirmPips * Point, Time[li_100 + 1], Magenta);
         if (g_ibuf_128[li_100 + 1] != 0.0) PrintPriceLabel(Low[li_100 + 1] - ConfirmPips * Point-110*Point, Time[li_100 + 1], Gold);
       
      }
   }
   if (gi_164 != Time[0]) {
      if (AlertPopups == TRUE) {
         if (g_ibuf_124[0] != 0.0 && gi_192 == 1) {
            Alert("VFA BUY candle " + TimeToStr(gi_160, TIME_MINUTES) + " " + Symbol());
            PlaySound("alert2.wav");
         }
         if (g_ibuf_128[0] != 0.0 && gi_192 == 2) {
            Alert("VFA SELL candle " + TimeToStr(gi_160, TIME_MINUTES) + " " + Symbol());
            PlaySound("alert2.wav");
         }
      }
      ls_88 = "status";
      if (gi_192 == 0) ls_88 = ls_88 + " NO ALERTS";
      if (gi_192 == 1) ls_88 = ls_88 + " VFA BUY candle " + TimeToStr(gi_160, TIME_MINUTES);
      if (gi_192 == 2) ls_88 = ls_88 + " VFA SELL candle " + TimeToStr(gi_160, TIME_MINUTES);
      Print(ls_88);
      Print(TimeToStr(Time[1], TIME_MINUTES) + "  VFATrend " + DoubleToStr(ld_0, Digits) + 
      "  VFADXBB " + DoubleToStr(ld_8, Digits) + "  VFAVol " + DoubleToStr(ld_16, 1) +
         "  VFRange " + DoubleToStr(ld_24, Digits));
      gi_164 = Time[0];
      g_count_156 = 0;
   }
   if (Seconds() < g_second_152) g_second_152 = Seconds();
   if (AlertSoundFile != "" && Seconds() >= g_second_152 + 5) {
      if (g_ibuf_124[0] != 0.0 && g_count_156 < AlertSoundRepeats) {
         PlaySound("alert2.wav");
         g_second_152 = Seconds();
         g_count_156++;
      }
      if (g_ibuf_128[0] != 0.0 && g_count_156 < AlertSoundRepeats) {
         PlaySound("alert2.wav");
         g_second_152 = Seconds();
         g_count_156++;
      }
   }

   return (0);
}

void deinit() {
   string l_name_0;
   for (int li_8 = 0; li_8 < Bars; li_8++) {
      g_ibuf_124[li_8] = 0;
      g_ibuf_128[li_8] = 0;
   
   }
   if (ShowPriceLabels == TRUE) {
      for (li_8 = ObjectsTotal() - 1; li_8 >= 0; li_8--) {
         l_name_0 = ObjectName(li_8);
         if (StringFind(l_name_0, "_pricelabel", 0) == 0) ObjectDelete(l_name_0);
      }
   }
   Comment("");
}